VME Intensity Monitor - Feature #11031
Extraction sample device
Description

:BEAMXn([0:7]

Similar to #11028 but each element represents a sample right before extraction.

History

#1-12/01/2015 11:20 AM - John Diamond

Possible implementation based on a circular buffer of the last n samples:

® reset() -
1. Clear circular buffer
2. Reset extraction samples to 0
3. Attach to $07
4. Attach to extraction event
e sample() -
1. Sample intensity device
2. Push sample into the circular buffer
e exSample() -
1. sample() one more time
2. search backwards through circular buffer for extraction edge
3. push edge sample into the sample buffer
¢ endOfBeam() -
1. Detach from $07
2. Detach from extraction event

#2 - 12/01/2015 09:51 PM - John Diamond
- % Done changed from 0 to 20

Implemented CircularBuffer class and began implementing CycleDeviceEx.

#3 - 12/04/2015 09:54 PM - John Diamond
- % Done changed from 20 to 80

Complete implementation of extraction cycle device support.

Merged into origin/mirrdcct._master.

Added configurations for Ml and RR extraction devices to anubstartup.
Ready to test on anub.

#4 - 12/05/2015 01:48 PM - John Diamond
- % Done changed from 80 to 20

Refactored CycleDeviceEx and CycleDevicelnj to use a std::vector for the sample buffer instead of a native array.
Removed the size parameter from their constructors and cli commands.

#5 - 12/05/2015 01:48 PM - John Diamond
- % Done changed from 20 to 80

#6 - 12/06/2015 08:40 AM - John Diamond
- % Done changed from 80 to 90

Implemented ClassACNet accessors for CycleDevicelnj and CycleDeviceEx.

#7 - 12/09/2015 09:39 AM - John Diamond

Added a sanity check to CycleDevicelnj::sample() and CycleDeviceEx::exSample() to make sure we're not recording an infinite number of
injection/extraction samples.

#8 - 12/09/2015 10:45 AM - John Diamond

Fixed a program exception bug in the circular buffer implementation.
Verified that the CB is being filled but don't have events at the moment to test edge detection...

#9 - 12/09/2015 08:18 PM - John Diamond

Beams & events came backs this evening and it appears that the extraction sample on the $E3 is being taken:

4: Machine:

However, the MI DCCT digitizer is returning Oxffffs for intensity at the moment so CycleDeviceEx::exSample() can't find an edge:

3: Ma

$e3, eob: $e6, inten ID: 1

Recycler, reset:
Injection: event: $e4,
Extraction: event: $f£3,
0: event: $e4 delay: 0
1: event: $e4 delay: 6
2: event: $fe delay: O
3: event: $fe delay: 0
4: event: $fe delay: O
5: event: $£f3 delay: O

chine:
Injection:
Extraction:
0: event:
l: event:
2: event:
3: event:
4: event:
5: event:

Main Injector,

event:

eve
$a3
$22
$25
Sfe
$a9
S$2f

Sa3,

nt: $a9,

delay:
delay:
delay:
delay:
delay:
delay:

o O O O O O

So it appears that the algorithm is working properly.

ACL> read R:DCCTX3[0:7]

R:DCCTX3 =

1637.05
0

0
E12

delay: 5, n: 6, samples: [20629,21661,22651,23548,24457,25347]
delay: 0, CB cap/size: 50/50, n: 1, samples:

sample: 31265
0 sample: 30238
sample: 0
sample: O
sample: 0
sample: 31401

reset: $2a, eob: $26, inten ID: 0
delay: 5, n: 0, samples: []

delay: 0, CB cap/size: 50/50, n: 0, samples:
sample: 0

sample: -1
sample: -1
sample: 0
sample: -1
sample: -1

Also, the extraction array device is reporting correctly:

The anub startup script is configured for and the following extraction array devices have been created:

1:DCCTX0
1:DCCTX1
1:DCCTX3
I:DCCTXA
R:DCCTX3

#10 - 12/09/2015 08:19 PM - John Diamond

- Status changed from Assigned to Closed

- % Done changed from 90 to 100
